README.mingw 6.7 KB
Newer Older
1
Software to install
smorlat's avatar
smorlat committed
2 3
*******************

4 5 6 7 8 9 10 11 12 13 14 15 16
Download lastest mingw-get-inst.exe from http://www.mingw.org
Run mingw-get-inst.exe. Choose "download lastest catalogues".
In the feature list, select:
* C compiler
* C++ compiler
* Mingw developer toolkit
Let the installer fetch and install everything.

In mingw shell, run

mingw-get install msys-zip
mingw-get install msys-unzip
mingw-get install msys-wget
17
mingw-get install msys-libopenssl
18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50

mkdir -p /opt/perl/bin
cp /bin/perl /opt/perl/bin/.

cd ~
#Download intltool
wget http://ftp.acc.umu.se/pub/GNOME/binaries/win32/intltool/0.40/intltool_0.40.4-1_win32.zip

Download lastest linphone-deps-win32 zip from  
http://download.savannah.gnu.org/releases-noredirect/linphone/misc
using your browser. 

Download lastest gtk+ win32 bundle from http://www.gtk.org 

Install all these three package in /:

cd /
unzip ~/intltool_0.40.4-1_win32.zip
unzip <path to gtk bundle zip>
unzip <path to linphone-deps>

#Install GTK+ Outcrop theme, the one used by linphone for distribution.
cd /share/themes
wget http://art.gnome.org/download/themes/gtk2/1122/GTK2-Outcrop.tar.gz
tar -xvzf GTK2-Outcrop.tar.gz

#Remove the special stdint.h and inttypes.h included in linphone-deps: it is for MSVC only.
#Mingw will use the one in /mingw/include
rm /include/stdint.h /include/inttypes.h

#Remove libgcc specific libraries, only needed for MSVC:
rm /lib/libgcc.a /lib/libmingw32.a /lib/libmingwex.a

Sylvain Berfini's avatar
Sylvain Berfini committed
51 52
#To get the translations working, remove from C:/MinGW/lib :
libintl.a libintl.la libintl.dll.a
53 54

* Download and install Inno Setup Compiler (required only if you run 'make setup.exe'). Add it to your windows Path environment variable.
smorlat's avatar
smorlat committed
55

smorlat's avatar
smorlat committed
56 57 58
Get Linphone source code
************************

Simon Morlat's avatar
Simon Morlat committed
59 60
Install msys-git from (http://code.google.com/p/msysgit/). During installation you are asked to make a choice about how line endings are treated by git.
Choose "Checkout line endings as they are, commit as they are". THIS CHOICE IS VERY IMPORTANT. OTHERS BREAK AUTOMAKE.
smorlat's avatar
smorlat committed
61

smorlat's avatar
smorlat committed
62 63 64 65
It is recommended that you create a directory somewhere with a path without any spaces or ~ characters, for example
c:\sources\
Within msys-git bash, do
cd /c/sources
66
git clone git://git.savannah.nongnu.org/linphone.git --recursive
smorlat's avatar
smorlat committed
67 68


69
Building
simorl's avatar
simorl committed
70
********
71

simorl's avatar
simorl committed
72 73 74
WARNING: During the build, windows might slow down suddenly. Using ctl+alt+del to start the windows system monitor,
 you might see a process 'LVpSRV.exe' or something like this that eats 90% of cpu.
Kill it. Don't know what it is, but once killed, windows runs normally.
75

76 77
#Compile and install tunnel
cd tunnel && ./autogen.sh && ./configure --prefix=/opt/linphone && make && make install
smorlat's avatar
smorlat committed
78
#run autogen.sh after a git checkout or update
79
./autogen.sh
smorlat's avatar
smorlat committed
80
./configure --prefix=/opt/linphone --enable-shared --disable-static
81
make
smorlat's avatar
smorlat committed
82
#will install to /opt/linphone, required for compilation of plugins.
simorl's avatar
simorl committed
83 84 85
make install
#make a binary zip of linphone
make zip
simorl's avatar
simorl committed
86 87
#additionally you can make binary installer if you have Inno Setup 5 installed in its default path
make setup.exe
88
#now you're done, you have a fresh linphone windows installer in the current directory.
89 90 91 92

#build plugins
cd mediastreamer2/plugins/msx264
./autogen.sh
smorlat's avatar
smorlat committed
93
PKG_CONFIG_PATH=/opt/linphone/lib/pkgconfig ./configure --prefix=/opt/linphone --enable-shared --disable-static
simorl's avatar
simorl committed
94 95
#make a binary zip of this plugin
make zip
smorlat's avatar
smorlat committed
96 97
#or make an installer
make setup.exe
98

smorlat's avatar
smorlat committed
99
#the buddylookup plugin enables lookup of buddies in a remote database using xml-rpc over http/https.
smorlat's avatar
smorlat committed
100
cd coreapi/plugins/buddylookup
101
./autogen.sh
simorl's avatar
simorl committed
102 103 104 105
PKG_CONFIG_PATH=/opt/linphone/lib/pkgconfig ./configure --prefix=/opt/linphone --enable-shared --disable-static 
make
#make a binary zip of this plugin
make zip
106 107 108 109 110


******************************************************
*      Notes about linphone-deps generation          *
******************************************************
smorlat's avatar
smorlat committed
111 112 113 114 115 116

Linphone-deps is a collection of linphone dependencies, that are for some of them difficult
to find as windows binaries.
These notes are useful if you want to upgrade part of the software that is included in the
linphone-deps packages.

117 118 119 120 121 122 123 124 125 126 127 128 129
List of software included in linphone-deps:
libosip2  (compiled)
libeXosip2 (compiled)
libavcodec, libavutil, libavformat, libavdevice, libswscale (compiled, all these from ffmpeg)
libtheora (from the web)
libx264 (compiled from the version distributed from linphone's web site)
libogg (from the web)
libspeex, libspeexdsp (compiled, statically to workaround a dll-related crash)
libgnutls (from the web)
libgsm (from the web)
libxml2 (compiled)
libsoup (compiled)

smorlat's avatar
smorlat committed
130 131 132
Remarks:
For every package compiled that goes into linphone-deps, .la files (libtool files) must be removed to avoid libtool errors.
When running "make install DESTDIR=<somepath>", somepath must be absolute and should not contain any ~ or space.
133

smorlat's avatar
smorlat committed
134 135
- building ffmpeg 
  ./configure --enable-shared --disable-static --enable-memalign-hack --extra-cflags="-fno-common" --enable-gpl && make
smorlat's avatar
smorlat committed
136
  make install DESTDIR=/home/<myuser>/ffmpeg-install
smorlat's avatar
smorlat committed
137
  Copy to ~/ffmpeg-install/usr/local/* to linphone-deps/.
smorlat's avatar
smorlat committed
138 139 140 141
  Copy also all *.dll.a files from the build tree to lib/ directort of linphone-deps. These are the implibs necessary to link a program against the dlls.

- building libxml2: the binaries found on the internet are generated with MSVC++, and for obscure reason they are not suitable for building libsoup 
  (that requires libxml2).
smorlat's avatar
smorlat committed
142
  ./configure --enable-shared --disable-static && make && make install DESTDIR=/home/<myuser>/libxml2-install
smorlat's avatar
smorlat committed
143 144 145
  copy ~/libxml2-install/usr/local/* into linphone-deps/.

- building x264:
smorlat's avatar
smorlat committed
146
 
smorlat's avatar
smorlat committed
147 148 149 150 151 152 153
  * download yasm normal version windows executable from yasm project page:
  http://www.tortall.net/projects/yasm/wiki/Download
  copy it as /usr/local/bin/yasm.exe

  cd into x264/ dir then run:
  ./configure --enable-pic
  make
smorlat's avatar
smorlat committed
154
  make install DESTDIR=/home/<myuser>/x264-install
smorlat's avatar
smorlat committed
155
  then copy the content of ~/x264-install/usr/local/ into linphone-deps/.
156

smorlat's avatar
smorlat committed
157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179
- libgnutls (required for libsoup https support)
	- download binary zip from http://josefsson.org/gnutls4win.org
	- add to linphone-deps

- building libsoup (only required for buddylookup plugin)
	- download source from gnome ftp (warning: at the time of the writing only version 2.26.x can compile with the 
		glib version supplied in the gtk-bundle, 2.27 requires a new version of glib)
	- uncompress libgnutls zip in /
	- make sure you have libxml2 installed in /
	- apply a bugfix patch (fix gnutls support on windows, completely broken otherwise). The patch
		is in linphone-deps/src, apply it this way:
		cd libsoup-2.26.*
		cd libsoup
		patch -p0 < libsoup-gnutls-bugfix.patch
	- run:
		./configure --prefix=/usr --enable-shared --disable-static
		make
		make install
		make install DESTDIR=/home/<myuser>/libsoup-install
	- copy ~/libsoup-install/usr/* into linphone-deps/

Once you have everything in linphone-deps, remove .la files from lib:
	cd lib && rm -f *.la